chiark / gitweb /
Test suite: Make t-policy more robust, and work in installed-package mode
[dgit.git] / tests / lib
1 #
2
3 exec 2>&1
4 set -x
5 set -o pipefail
6
7 . tests/lib-core
8
9 t-set-intree
10
11 : ${DGIT_TEST_DEBUG:=-D}
12 export DGIT_TEST_DEBUG
13
14 root=`pwd`
15 troot=$root/tests
16 testname="${DGIT_TEST_TESTNAME-${0##*/}}"
17
18 tmp=$ADTTMP
19 if [ x"$tmp" = x ]; then
20         mkdir -p tests/tmp
21         tmp=tests/tmp/$testname
22         rm -rf $tmp
23         mkdir $tmp
24 fi
25 cd $tmp
26
27 tmp=`pwd`
28
29 t-set-using-tmp
30
31 ln -f $troot/ssh ssh
32
33 mkdir -p $tmp/gnupg
34 cp $troot/gnupg/* $tmp/gnupg
35 chmod go-rw $tmp/gnupg/*
36
37 export DEBCHANGE_VENDOR=dpkg
38
39 mkdir -p $tmp/incoming
40 cat <<END >$tmp/dput.cf
41 [test-dummy]
42 method                  = local
43 incoming                = $tmp/incoming
44 run_dinstall            = 0
45 END
46
47 t-expect-fail () {
48         local mpat="$1"; shift
49
50         local grepper=fgrep
51         case "$mpat" in
52         [A-Z]:*)
53                 case "$mpat" in
54                 E:*)    grepper=egrep   ;;
55                 F:*)    grepper=fgrep   ;;
56                 *)      fail "bad mpat prefix in $mpat";;
57                 esac
58                 mpat=${mpat#[A-Z]:}
59                 ;;
60         esac
61
62         set +o pipefail
63         LC_MESSAGES=C "$@" 2>&1 | tee $tmp/t.output
64         local ps="${PIPESTATUS[*]}"
65         set -o pipefail
66
67         case $ps in
68         "0 0")  fail "command unexpectedly succeeded (instead of: $mpat)" ;;
69         *" 0")  ;;
70         *)      fail "tee failed"  ;;
71         esac
72
73         $grepper -e "$mpat" $tmp/t.output ||
74                 fail "error message not found"
75 }
76
77 t-expect-push-fail () {
78         local mpat="$1"; shift
79
80         local triedpush=`git rev-parse HEAD`
81
82         t-reporefs pre-push
83         t-expect-fail "$mpat"  "$@"
84         t-reporefs post-push
85         diff $tmp/show-refs.{pre,post}-push
86
87         t-git-objects-not-present '' $triedpush
88
89         eval "$t_expect_push_fail_hook"
90 }
91
92 t-git-objects-not-present () {
93         # t-git-objects-not-present GITDIR|'' OBJID [...]
94         # specifying '' means the repo for package $p
95         local gitdir="${1-$tmp/git/$p.git}"
96         local obj
97         if ! [ -e "$gitdir" ]; then return; fi
98         for obj in "$@"; do
99                 GIT_DIR=$gitdir \
100                 t-expect-fail 'unable to find' \
101                 git cat-file -t $obj
102         done
103 }
104
105 t-reporefs () {
106         local whichoutput=$1; shift
107         local outputfile="$tmp/show-refs.$whichoutput"
108         (set -e
109          exec >"$outputfile"
110          if test -d $tmp/git/$p.git; then
111                 cd $tmp/git/$p.git
112                 git show-ref |sort
113         fi)
114 }
115
116 t-untar () {
117         local tarfile=$1.tar
118         local edittree=$1.edit
119         if test -d "$edittree"; then
120                 cp -al "$edittree"/* .
121         else
122                 tar xf "$tarfile"
123         fi
124 }
125
126 t-worktree () {
127         rm -rf $p
128         t-untar $troot/worktrees/${p}_$1
129 }
130
131 t-git () {
132         p=$1
133         v=$2
134         mkdir -p $tmp/git
135         local gs=$troot/git-srcs/${p}_$v.git
136         (set -e; cd $tmp/git; t-untar $gs)
137 }
138
139 t-git-none () {
140         mkdir -p $tmp/git
141         (set -e; cd $tmp/git; tar xf $troot/git-template.tar)
142 }
143
144 t-has-ancestor () {
145         local now=`git rev-parse HEAD`
146         local ancestor=`git rev-parse $1^{}`
147         local mbase=`git merge-base $ancestor $now`
148         if [ x$mbase != x$ancestor ]; then
149                 fail "not ff $ancestor..$now, $mbase != $ancestor"
150         fi
151 }
152
153 t-prep-newpackage () {
154         p=$1
155         v=$2
156         t-archive-none $p
157         t-git-none
158         t-worktree $v
159         cd $p
160         if ! git show-ref --verify --quiet refs/heads/master; then
161                 git branch -m dgit/sid master
162                 git remote rm dgit
163         fi
164         cd ..
165 }
166
167 t-archive-none () {
168         p=$1
169         mkdir -p $tmp/aq $tmp/mirror/pool/main
170
171         local suite=sid
172
173         >$tmp/aq/package.$suite.$p
174         t-archive-updated $suite $p
175
176         >$tmp/aq/package.new.$p
177         t-archive-updated new $p
178
179         ln -s sid $tmp/aq/dsc_in_suite/unstable
180         cat <<'END' >$tmp/aq/suites
181 [
182    {
183       "archive" : "ftp-master",
184       "codename" : "sid",
185       "components" : [
186          "main",
187          "contrib",
188          "non-free"
189       ],
190       "name" : "unstable",
191       "dakname" : "unstable"
192    }
193 ]
194 END
195 }
196
197 t-archive-updated () {
198         local suite=$1
199         local p=$2
200         local suitedir=$tmp/aq/dsc_in_suite/$suite
201         mkdir -p $suitedir
202         perl <$tmp/aq/package.$suite.$p >$suitedir/$p -wne '
203                 use JSON;
204                 use strict;
205                 our @v;
206                 m{^(\S+) (\w+) ([^ \t/]+)/(\S+)} or die;
207                 push @v, {
208                         "version" => "$1",
209                         "sha256sum" => "$2",
210                         "component" => "$3",
211                         "filename" => "$4",
212                 };
213                 END {
214                         print to_json \@v or die $!;
215                 }
216         '
217 }
218
219 t-archive-process-incoming () {
220         local suite=$1
221         mv $tmp/incoming/${p}_${v}[._]* $tmp/mirror/pool/main/
222         t-archive-query "$suite"
223 }
224
225 t-archive-query () {
226         local suite=${1-sid}
227         local dscf=main/${p}_${v}.dsc
228         local sha=`sha256sum <$tmp/mirror/pool/$dscf`
229         echo "${v} ${sha%  -} $dscf" >>$tmp/aq/package.$suite.${p}
230         t-archive-updated $suite $p
231 }
232
233 t-archive () {
234         t-archive-none $1
235         v=$2
236         local dscf=${p}_$2.dsc
237         rm -f $tmp/mirror/pool/main/${p}_*
238         ln $troot/pkg-srcs/${p}_${2%-*}* $tmp/mirror/pool/main/
239         t-archive-query
240         rm -rf $tmp/extract
241         mkdir $tmp/extract
242         (set -e; cd $tmp/extract; dpkg-source -x ../mirror/pool/main/$dscf)
243 }
244
245 t-git-dir-time-passes () {
246         touch -d 'last year' $tmp/git/$p.git
247 }
248
249 t-git-dir-check () {
250         local gitdir=$tmp/git/$p.git
251         case "$1" in
252         enoent)
253                 if test -e "$gitdir"; then fail "$gitdir exists"; fi
254                 return
255                 ;;
256         public) wantstat='7[75]5' ;;
257         secret) wantstat='7[70]0' ;;
258         *)      fail "$1 t-git-dir-check ?" ;;
259         esac
260         gotstat=`stat -c%a $gitdir`
261         case "$gotstat" in
262         *$wantstat) return ;;
263         *)      fail "$gitdir has mode $gotstat, expected $wantstat" ;;
264         esac
265 }
266
267 t-rm-dput-dropping () {
268         rm -f $tmp/${p}_${v}_*.upload
269 }
270
271 t-dgit () {
272         local dgit=${DGIT_TEST-dgit}
273         : '
274 {{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{'
275         $dgit --dgit=$dgit --dget:-u --dput:--config=$tmp/dput.cf \
276                 -dtest-dummy $DGIT_TEST_OPTS $DGIT_TEST_DEBUG \
277                 -k39B13D8A "$@"
278         : '}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}
279 '
280 }
281
282 t-diff-nogit () {
283         diff --exclude=.git --exclude=.pc -ruN $*
284 }
285
286 t-cloned-fetched-good () {
287         t-diff-nogit ../extract/$p-${v%-*} .
288         t-clean-on-branch dgit/sid
289         t-refs-same-start
290         t-refs-same \
291                 refs/heads/dgit/sid \
292                 refs/remotes/dgit/dgit/sid
293         t-refs-notexist refs/dgit/unstable refs/remotes/dgit/dgit/unstable
294 }
295
296 t-output () {
297         printf "%s\n" "$1" >$tmp/t.want
298         shift
299         "$@" >$tmp/t.got
300         diff $tmp/t.want $tmp/t.got
301 }
302
303 t-clean-on-branch () {
304         t-output "## $1" git status -b --porcelain
305 }
306
307 t-git-get-ref-exact () {
308         local ref=$1
309         # does not dereference, unlike t-git-get-ref
310         case "$ref" in
311         refs/*) ;;
312         *) fail "t-git-get-ref-exact bad $ref" ;;
313         esac
314         git for-each-ref --format='%(objectname)' "[r]efs/${ref#refs/}"
315 }
316
317 t-git-get-ref () {
318         local ref=$1
319         case "$ref" in
320         refs/*) ;;
321         *) fail "t-git-get-ref bad $ref" ;;
322         esac
323         (git show-ref -d $1 || test $? = 1) | perl -ne '
324                 $x = $1 if m#^(\w+) \Q'$1'\E(?:\^\{\})?$#;
325                 END { print "$x\n" if length $x; }
326         '
327 }
328
329 t-ref-same () {
330         local name="$1"
331         local val=`t-git-get-ref $name`
332         t-ref-same-val "$name" $val
333 }
334
335 t-ref-head () {
336         local val=`git rev-parse HEAD`
337         t-ref-same-val HEAD $val
338 }
339
340 t-ref-same-val () {
341         local name="$1"
342         local val=$2
343         case "$t_ref_val" in
344         '')             ;;
345         "$val")         ;;
346         *)              fail "ref varies: $name: $val != $t_ref_val" ;;
347         esac
348         t_ref_val="$val"
349 }
350
351 t-refs-same-start () {
352         t_ref_val=''
353 }
354
355 t-refs-same () {
356         local g
357         for g in $*; do
358                 t-ref-same $g
359         done
360 }
361
362 t-refs-notexist () {
363         local val
364         for g in $*; do
365                 val=`t-git-get-ref $g >$tmp/t.refx`
366                 if [ "x$val" != x ]; then
367                         fail "ref $g unexpectedly exists ($val)"
368                 fi
369         done
370 }
371
372 t-v-tag () {
373         echo refs/tags/debian/${v//\~/_}
374 }
375
376 t-pushed-good () {
377         local branch=$1
378         t-ref-dsc-dgit
379         t-refs-same \
380                 refs/heads/$branch \
381                 `t-v-tag` \
382                 refs/remotes/dgit/dgit/sid
383         t-refs-notexist \
384                 refs/heads/dgit/unstable \
385                 refs/remotes/dgit/dgit/unstable
386         (set -e; cd $tmp/git/$p.git
387          t-refs-same \
388                 refs/dgit/sid \
389                 `t-v-tag`
390          t-refs-notexist \
391                 refs/dgit/unstable
392         )
393         git verify-tag `t-v-tag`
394 }
395
396 t-822-field () {
397         local file=$1
398         local field=$2
399         perl -e '
400                 use Dpkg::Control::Hash;
401                 my $h = new Dpkg::Control::Hash allow_pgp=>1;
402                 $h->parse(\*STDIN,"'"$file"'");
403                 my $val = $h->{"'$field'"},"\n";
404                 die "'"$file $field"'" unless defined $val;
405                 print $val,"\n";
406         ' <$file
407 }
408
409 t-stunt-envvar () {
410         local var=$1
411         local tstunt=$2
412         eval '
413                 case "'$var'" in
414                 "$tstunt:"*)    ;;
415                 *":$tstunt:"*)  ;;
416                 *)              '$var'="$tstunt:$'$var'" ;;
417                 esac
418         '
419 }
420
421 t-tstunt () {
422         local tstunt=$tmp/tstunt
423         t-stunt-envvar PATH $tstunt
424         t-stunt-envvar PERLLIB $tstunt
425         local f
426         for f in "$@"; do
427                 f="./$f"
428                 local d="$tstunt/${f%/*}"
429                 mkdir -p $d
430                 ln -sf "$troot/tstunt/$f" "$d"/.
431         done
432 }
433
434 t-tstunt-parsechangelog () {
435         t-tstunt dpkg-parsechangelog Dpkg/Changelog/Parse.pm
436 }
437
438 t-prep-mergechangelogs () {
439         local b=merge.dpkg-mergechangelogs
440         git config $b.name 'debian/changelog merge driver'
441         git config $b.driver 'dpkg-mergechangelogs -m %O %A %B %A'
442         mkdir -p .git/info
443         echo >>.git/info/attributes \
444                 'debian/changelog merge=dpkg-mergechangelogs'
445 }
446
447 t-ref-dsc-dgit () {
448         local dsc=${p}_${v}.dsc
449         local val=`t-822-field $tmp/incoming/$dsc Dgit`
450         perl -e '$_=shift @ARGV; die "$dsc Dgit $_ ?" unless m/^\w+\b/;' "$val"
451         t-ref-same-val $dsc "$val"
452 }
453
454 t-apply-diff () {
455         local v1=$1
456         local v2=$2
457         (cd $troot/pkg-srcs;
458          debdiff ${p}_${v1}.dsc ${p}_${v2}.dsc || test $? = 1) \
459          | patch -p1 -u
460 }
461
462 t-commit () {
463         local msg=$1
464         v=1.$revision
465         dch -v$v --distribution unstable "$1"
466         git add debian/changelog
467         debcommit
468         revision=$(( $revision + 1 ))
469 }
470
471 t-git-config () {
472         git config --global "$@"
473 }
474
475 t-drs () {
476         export DGIT_TEST_TROOT=$troot
477  t-git-config dgit-distro.test-dummy.git-url "ext::$troot/drs-git-ext %S "
478  t-git-config dgit-distro.test-dummy.git-check true
479  t-git-config dgit-distro.test-dummy.git-create true
480         cp $troot/gnupg/{dd.gpg,dm.gpg,dm.txt} $tmp/.
481         cp $troot/suites $tmp/.
482
483         drs_dispatch=$tmp/distro=test-dummy
484         mkdir $drs_dispatch
485
486         if [ "x$DGIT_TEST_INTREE" != x ]; then
487                 ln -sf "$DGIT_TEST_INTREE" $drs_dispatch/dgit-live
488         fi
489
490         ln -sf $tmp/git $drs_dispatch/repos
491         ln -sf $tmp/suites $tmp/dm.txt $drs_dispatch/
492         mkdir -p $drs_dispatch/keyrings
493         ln -sf $tmp/dd.gpg $drs_dispatch/keyrings/debian-keyring.gpg
494         ln -sf $tmp/dm.gpg $drs_dispatch/keyrings/debian-maintainers.gpg
495         ln -sf /bin/true $drs_dispatch/policy-hook
496 }
497
498 t-dsd () {
499         t-drs
500  t-git-config dgit-distro.test-dummy.ssh "$troot/dsd-ssh"
501  t-git-config dgit-distro.test-dummy.git-check ssh-cmd
502  t-git-config dgit-distro.test-dummy.git-create true
503  t-git-config dgit-distro.test-dummy.git-url \
504                 "ext::$troot/dsd-ssh X %S /dgit/test-dummy/repos"
505
506  t-git-config dgit-distro.test-dummy.diverts.drs /drs
507  t-git-config dgit-distro.test-dummy/drs.ssh "$troot/ssh"
508  t-git-config dgit-distro.test-dummy/drs.git-url $tmp/git
509  t-git-config dgit-distro.test-dummy/drs.git-check ssh-cmd
510  t-git-config dgit-distro.test-dummy/drs.git-create ssh-cmd
511
512         echo 'no-such-package* drs' >$drs_dispatch/diverts
513 }
514
515 t-policy-admin () {
516         ${DGIT_INFRA_PFX}dgit-repos-admin-debian --repos $tmp/git "$@"
517 }
518
519 t-policy () {
520         local policyhook=$1
521         policyhook=${DGIT_INFRA_PFX}$policyhook
522         case $policyhook in
523         */*)    ;;
524         *)      policyhook=`type -P $policyhook` ;;
525         esac
526         ln -sf "$policyhook" $drs_dispatch/policy-hook
527 }
528
529 t-debpolicy () {
530         t-dsd
531         t-policy dgit-repos-policy-debian
532
533         mkdir $tmp/git
534         t-policy-admin create-db
535 }
536
537 t-policy-periodic () {
538         ${DGIT_REPOS_SERVER_TEST-dgit-repos-server} \
539                 test-dummy $drs_dispatch '' --cron
540 }
541
542 t-chain-test () {
543         local ct=$1
544         local d=${0%/*}
545         cd $root
546         export DGIT_TEST_TESTNAME="$testname"
547         export ADTTMP=$tmp
548         exec "$d/$ct"
549 }       
550
551 t-alt-test () {
552         local t=${0##*/}
553         t-${t%%-*}
554         t-chain-test "${t#*-}"
555 }